#!/usr/bin/perl -w

# Copyright (c) 2001 imacat
# vҦ (c) 2001 ̺
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# {OۥѳnAziHӦۥѳn|] Free Software Foundation
# ^X GNU qΤ@\iұڡ] GNU General Public License ^ĤG
# ӭקMsoGo@{AΪ̦ۥѿܨϥΥsC
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# oGo@{تOƱ楦ΡASOCƦܨSAXSwت
# tOCԲӪpаѾ\ GNU qΤ@\iҡC
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
# zӤwgM{@_@ GNU qΤ@\iҪƥCpG٨SAg
# HG Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# ɮצW:	arclog.pl
# ɮ׻:	Perl Oɫkɵ{
# ɮת:	1.4.2dev
# ɮק@:	̺ <imacat@mail.imacat.idv.tw>
# Z:	2001-01-05
# vr:	(c) 2001 ̺

# Filename:	arclog.pl
# Description:	Perl script to archieve log files monthly
# Version:	1.4.2dev
# Author:	imacat <imacat@mail.imacat.idv.tw>
# Date:		2001-01-05
# Copyright:	(c) 2001 imacat

use 5.005;
use strict;
use Fcntl qw(:flock);
use IO::File qw();
use IO::Handle qw(autoflush);
use Getopt::Long qw(GetOptions);
use Cwd qw(cwd);
use File::Basename qw(basename fileparse);
use File::Spec::Functions qw(file_name_is_absolute catfile splitdir curdir updir);
use File::Temp qw(tempfile);
use Config qw(%Config);
use Date::Parse qw(str2time);
use Compress::Zlib qw(gzopen);

use vars qw($VERBOSE $COMPRESS $COMPRESS_SUFFIX $OVERRIDE @OVERRIDES $SORT $SORT_SIZE_LIMIT $DATE_RE);
$VERBOSE = 1;
$COMPRESS = 1;
$COMPRESS_SUFFIX = ".gz";
if (-t STDIN) {
	$OVERRIDE = "ask";
} else {
	$OVERRIDE = "fail";
}
@OVERRIDES = qw(overwrite append ignore fail ask);
$SORT = 0;
*SORT_SIZE_LIMIT = \50000000;

use vars qw($THIS_FILE $SHORTHELP $VERNO $VERSTR $HELPSTR);
$0 =~ /[^\/]*$/;
$THIS_FILE = $&;
$SHORTHELP = "Try `$THIS_FILE --help' for more information.";
*VERNO = \"1.4.2dev";
$VERSTR = "$& v$VERNO by imacat <imacat\@mail.imacat.idv.tw>";
$HELPSTR = << "EOF";
Usage: $THIS_FILE [-dqhv] [-p prefix] [logfile]
Archieve the log files monthly.

  -p,--prefix=pre    The prefix of the output files. The output files will be
                     named as pre.yyyymm, ie: pre.200001, pre.200002. If not
                     specified, the default prefix is the logfile pathname.
  --compress         Compress the archived files. (default)
  --nocompress       Don't compress the archived files.
  --sort             Sort the records in the log files by time.
  --nosort           Don't sort the records. (default)
  --override[=mode]  The override behavior when the target archived files
                     exist. Available modes are: overwrite, append, ignore,
                     fail and ask. If not specified, the default is "fail".
                     If specified without mode, the default is "overwrite".
  -d,--debug         Display debugging messages.
  -q,--quiet         Be quiet. Only yell when errors.
  -h,--help          Display this help.
  -v,--version       Display version number.
  logfile            The log file to be archieved.

EOF

main();
exit 0;

# main: Main program D{
sub main {
	local $_;
	my ($source, $output, $entry);
	my ($rec_counter, $val_counter, %mon_counter);
	my ($month, $this_month, $cur_month);
	my ($fh, $fh0, %fn, $gz);
	my ($override);
	
	($source, $output) = parse_args();
	
	# Open the log file }ҰO
	print "Opening the log file... " if $VERBOSE >= 2;
	open (SOURCE, "+<$source") || die "$THIS_FILE: $!";
	flock (SOURCE, LOCK_EX) || die "$THIS_FILE: $!";
	print "done\n" if $VERBOSE >= 2;
	
	# Process the records one by one @@Bz
	$rec_counter = 0;
	$val_counter = 0;
	$this_month = to_yyyymm(time);
	$cur_month = "";
	while (defined ($entry = <SOURCE>)) {
		# Check the log file format ˬdOɮ榡
		if (!defined $DATE_RE) {
			print "Checking the log file format... " if $VERBOSE >= 2;
			if ($entry =~ /^\S+ \S+ \S+ \[(.*?)\]/) {
				$DATE_RE = "^\\S+ \\S+ \\S+ \\[(.*?)\\]";
				print "apache\n" if $VERBOSE >= 2;
			} elsif ($entry =~ /^([A-Z][a-z]{2}  ?\d{1,2} \d{2}:\d{2}:\d{2}) /) {
				$DATE_RE = "^([A-Z][a-z]{2}  ?\\d{1,2} \\d{2}:\\d{2}:\\d{2}) ";
				print "syslog\n" if $VERBOSE >= 2;
			} else {
				print "fail\n" if $VERBOSE >= 2;
				$! = 1;
				die "$THIS_FILE: Unrecognized log file format";
			}
		}
		
		$rec_counter++;
		next unless $entry =~ /$DATE_RE/;
		next unless defined ($_ = str2time $1);
		$month = to_yyyymm($_);
		
		# New month -- close the previous archive file @ӤɡAɮ
		if ($month ne $cur_month) {
			# Close the previous month WӤ볡
			# This month -- don't close anything ɡAn
			if ($cur_month eq $this_month) {
				print "done\n" if $VERBOSE >= 2;
				print "" . format_number($mon_counter{$this_month}) . " records preserved for $this_month\n" if $VERBOSE >= 1;
			
			# Previous file opened -- close it eӤɮפw}ɡA
			} elsif (defined $fh && defined fileno $fh) {
				flock ($fh, LOCK_UN) || die "$THIS_FILE: $!";
				close ($fh) || die "$THIS_FILE: $!";
				print "done\n" if $VERBOSE >= 2;
				print "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
			
			# Ignored months -- report only A^έp
			} elsif (exists $fn{$cur_month} && !defined $fn{$cur_month}) {
				print "done\n" if $VERBOSE >= 2;
				print "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
			}
			
			# Open a new month }lU@Ӥ
			# This month -- open a temporary working file ж}Ȧs
			if ($month eq $this_month) {
				if (!defined $fh0) {
					($fh0 = tempfile) || die "$THIS_FILE: $!";
					flock ($fh0, LOCK_EX) || die "$THIS_FILE: $!";
				}
				print "Preserving records of $month... " if $VERBOSE >= 2;
			
			# Other months -- open file oж}
			} else {
				# First time -- open a new file Ĥ@ж}s
				if (!exists $fn{$month}) {
					$fn{$month} = "$output.$month";
					$fn{$month} .= $COMPRESS_SUFFIX if $COMPRESS;
					
					# Target file exists ɮפwsb
					if (-e $fn{$month}) {
						$override = $OVERRIDE;
						# If we should ask pGn@@߰ݪ
						while ($override eq "ask") {
							print "$fn{$month} already exists, (O)verwrite, (A)ppend, (I)gnore, (F)ail? [F] ";
							$_ = <STDIN>;
							chomp;
							# Overwrite \
							if (lc $_ eq "o" || lc $_ eq "overwrite") {
								$override = "overwrite";
							# Append [Wh
							} elsif (lc $_ eq "a" || lc $_ eq "append") {
								$override = "append";
							# Ignore 
							} elsif (lc $_ eq "i" || lc $_ eq "ignore") {
								$override = "ignore";
							# Fail 
							} elsif (lc $_ eq "f" || lc $_ eq "fail" || lc $_ eq "") {
								$override = "fail";
							# Else, ask again _hA
							} else {
								print "What?\n";
								$override = "ask";
							}
						}
						# Overwrite, do nothing \Aޥ
						if ($override eq "overwrite") {
						
						# Append, handle when opening file [WhA}ɮɦABz
						} elsif ($override eq "append") {
						
						# Ignore, undefine the filename A]ɦW
						} elsif ($override eq "ignore") {
							undef $fn{$month};
						
						# Else, stop processing A{
						} else {
							foreach (keys %mon_counter) {
								unlink ($fn{$_}) || die "$THIS_FILE: $!";
							}
							die "$THIS_FILE: File exists $fn{$month}";
						}
					}
					
					# Ignore, open nothing An}
					if (!defined $fn{$month}) {
						print "Ignoring records of $month... " if $VERBOSE >= 2;
					
					# Append, output the original to temporary working files sWAlO]giȦsɤ
					} elsif (-e $fn{$month} && $override eq "append") {
						print "Reading original records of $month... " if $VERBOSE >= 2;
						if ($COMPRESS) {
							$gz = gzopen($fn{$month}, "rb") || die "$THIS_FILE: " . $gz->gzerror();
							(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
							flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
							while ($gz->gzreadline($_) > 0) {
								(print $fh $_) || die "$THIS_FILE: $!";
							}
							$gz->gzclose() && die "$THIS_FILE: " . $gz->gzerror();
						} else {
							open (ORIGINAL, $fn{$month}) || die "$THIS_FILE: $!";
							flock (ORIGINAL, LOCK_SH) || die "$THIS_FILE: $!";
							(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
							flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
							print $fh $_ while <ORIGINAL>;
							flock (ORIGINAL, LOCK_UN) || die "$THIS_FILE: $!";
							close (ORIGINAL) || die "$THIS_FILE: $!";
						}
						print "done\n" if $VERBOSE >= 2;
						print "Appending records of $month... " if $VERBOSE >= 2;
					
					# Open a temporary working file }Ȧs
					} else {
						print "Archiving records of $month... " if $VERBOSE >= 2;
						(($fh, $fn{$month}) = tempfile) || die "$THIS_FILE: $!";
						flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
					}
				
				# Opened before, append it }LաХ[̫᭱
				} else {
					# Ignore, open nothing An}
					if (!defined $fn{$month}) {
						print "Ignoring records of $month... " if $VERBOSE >= 2;
					
					# Else, append _hA[̫᭱
					} else {
						print "Archiving records of $month... " if $VERBOSE >= 2;
						($fh = new IO::File ">>$fn{$month}") || die "$THIS_FILE: $!";
						flock ($fh, LOCK_EX) || die "$THIS_FILE: $!";
					}
				}
			}
			$cur_month = $month;
		}
		
		# Save it sih
		# This month, save to $fh0 As $fh0
		if ($month eq $this_month) {
			(print $fh0 $entry) || die "$THIS_FILE: $!";
		
		# Ignore, save nothing Ans
		} elsif (!defined $fn{$month}) {
		
		# Other months, save to $fh oAs $fh
		} else {
			(print $fh $entry) || die "$THIS_FILE: $!";
		}
		
		# Add the counter έp
		$mon_counter{$month} = 0 if !exists $mon_counter{$month};
		$mon_counter{$month}++;
		$val_counter++;
	}
	
	# If the log file is empty OɬOŪ
	if ($rec_counter == 0) {
		print "No records read\n" if $VERBOSE >= 1;
		exit 0;
	}
	
	# Previous is this month -- report only eӤOɡAɡAiέp
	if ($cur_month eq $this_month) {
		print "done\n" if $VERBOSE >= 2;
		print "" . format_number($mon_counter{$this_month}) . " records preserved for $this_month\n" if $VERBOSE >= 1;
	
	# Previous file opened -- close it oɮפw}ɡA
	} elsif (defined $fh && defined fileno $fh) {
		flock ($fh, LOCK_UN) || die "$THIS_FILE: $!";
		close ($fh) || die "$THIS_FILE: $!";
		print "done\n" if $VERBOSE >= 2;
		print "" . format_number($mon_counter{$cur_month}) . " records archived for $cur_month\n" if $VERBOSE >= 1;
	
	# Ignored months -- report only A^έp
	} elsif (!defined $fn{$cur_month}) {
		print "done\n" if $VERBOSE >= 2;
		print "" . format_number($mon_counter{$cur_month}) . " records ignored for $cur_month\n" if $VERBOSE >= 1;
	}
	
	# Delete the filenames of ignored months RɦW
	foreach (keys %fn) {
		delete $fn{$_} unless defined $fn{$_};
	}
	
	# Sort the archives by date/time ɶƧ
	sort_arcs (%fn) if $SORT;
	
	# Save the archives Nkɫ᪺Os
	save_arcs ($output, %fn);
	
	# Restart the log file mO
	print "Restarting the log file... " if $VERBOSE >= 2;
	seek (SOURCE, 0, 0) || die "$THIS_FILE: $!";
	truncate (SOURCE, 0) || die "$THIS_FILE: $!";
	print "done\n" if $VERBOSE >= 2;
	
	# Move the records of this month back ⥻Os^Oɤ
	if (defined fileno $fh0) {
		print "Returning records of $this_month... " if $VERBOSE >= 2;
		seek ($fh0, 0, 0) || die "$THIS_FILE: $!";
		print SOURCE while <$fh0>;
		print "done\n" if $VERBOSE >= 2;
		delete $mon_counter{$this_month};
	}
	
	# Close the log file O
	print "Closing the log file... " if $VERBOSE >= 2;
	flock ($fh0, LOCK_UN) || die "$THIS_FILE: $!";
	close ($fh0) || die "$THIS_FILE: $!";
	flock (SOURCE, LOCK_UN) || die "$THIS_FILE: $!";
	close (SOURCE) || die "$THIS_FILE: $!";
	print "done\n" if $VERBOSE >= 2;
	
	# Print the statistics ܲέpG
	print "" . format_number(0 + keys %fn) . " archieve file(s) written, " . ((time() - $^T) . " second(s) elapsed.\n") if $VERBOSE >= 1;
	return;
}

# parse_args: Parse the arguments ѼƸѪR
sub parse_args {
	local $_;
	my ($source, $output, $entry);
	
	# Get the arguments oѼ
	eval {
		local $SIG{__WARN__} = sub { die $_[0]; };
		GetOptions(	"compress!"=>\$COMPRESS,
				"sort!"=>\$SORT,
				"override:s"=>\$OVERRIDE,
				"debug"=>sub { $VERBOSE = 2; },
				"quiet"=>sub { $VERBOSE = 0; },
				"help"=>sub { print $HELPSTR; exit 0; },
				"version"=>sub { print "$VERSTR\n"; exit 0; });
	};
	die "$THIS_FILE: $@" if $@;
	$OVERRIDE = "overwrite" if $OVERRIDE eq "";
	$OVERRIDE = lc $OVERRIDE;
	die "$THIS_FILE: Unknown override mode \"$OVERRIDE\"" unless grep $_ eq $OVERRIDE, @OVERRIDES;
	
	$source = shift @ARGV if @ARGV > 0;
	
	# Set the verbose level ]wT
	autoflush STDOUT if $VERBOSE >= 2;
	
	# Check the log file ˬdO
	die "$THIS_FILE: Please specify the log file.\n$SHORTHELP\n"
		unless defined $source;
	$source = rel2abs ($source);
	$source = catfile ($source, "access_log") if -d $source;
	die "$THIS_FILE: no such file or directory: $source\n$SHORTHELP\n"
		unless -e $source;
	die "$THIS_FILE: invalid file: $source\n$SHORTHELP\n"
		unless -f $source;
	die "$THIS_FILE: permission denied: $source\n$SHORTHELP\n"
		unless -r $source && -w $source;
	
	# Check the output file prefix ˬdXɮ
	$output = $source unless defined $output;
	$output = rel2abs ($output);
	$_ = (fileparse $output)[1];
	die "$THIS_FILE: no such file or directory: $_\n$SHORTHELP\n"
		unless -e $_;
	die "$THIS_FILE: invalid directory: $_\n$SHORTHELP\n"
		unless -d $_;
	die "$THIS_FILE: permission denied: $_\n$SHORTHELP\n"
		unless -w $_;
	
	return ($source, $output);
}

# sort_arcs: Sort the archives by date/time ɶƧ
sub sort_arcs {
	local $_;
	my ($month, %fn, %order, $date, $cur_date, $num_format);
	%fn = @_;
	$num_format = "%0" . (int ((log $SORT_SIZE_LIMIT) / (log 10)) + 1) . "d";
	
	# Sort each file CɮױƧ
	foreach $month (sort keys %fn) {
		print "Sorting records of $month... " if $VERBOSE >= 2;
		# Abort if over the limit WLjpWN
		if (-s $fn{$month} > $SORT_SIZE_LIMIT) {
			print "failed.\n" if $VERBOSE >= 2;
			warn "$THIS_FILE: Too many records. Abort.\n";
			next;
		
		# Sort directly if less than 50MB  50MB Ƨ
		} else {
			open (DATA, "+<$fn{$month}") || die "$THIS_FILE: $!";
			flock (DATA, LOCK_EX) || die "$THIS_FILE: $!";
			@_ = <DATA>;
			%order = qw();
			for ($_ = 0; $_ < @_; $_++) {
				$_[$_] =~ /$DATE_RE/;
				$order{str2time($1) . " " . sprintf($num_format, $_)} = $_;
			}
			seek (DATA, 0, 0) || die "$THIS_FILE: $!";
			truncate (DATA, 0) || die "$THIS_FILE: $!";
			foreach (sort keys %order) {
				if (!defined $_[$order{$_}]) {
					print "$month: \"$_\" \"$order{$_}\" \"$_[$order{$_}]\"\n";
					<STDIN>;
				}
				(print DATA $_[$order{$_}]) || die "$THIS_FILE: $!";
			}
			flock (DATA, LOCK_UN) || die "$THIS_FILE: $!";
			close (DATA) || die "$THIS_FILE: $!";
		}
		print "done\n" if $VERBOSE >= 2;
	}
	return;
}

# save_arcs: Save the archives Nkɫ᪺Os
sub save_arcs {
	local $_;
	my ($output, $month, $path, $file, $gz, $size_src, $size_comp, $ratio, %tmpfn);
	($output, %tmpfn) = @_;
	
	# Save each file from the temporary working files qȦsɤs
	foreach $month (sort keys %tmpfn) {
		# Obtain the filename oɦW
		$path = "$output.$month";
		$path .= $COMPRESS_SUFFIX if $COMPRESS;
		$file = basename($path);
		$size_src = -s $tmpfn{$month};
		
		# Save s
		print "Saving records of $month to $path... " if $VERBOSE >= 2;
		# Open the temporary working file }ҼȦs
		open (TEMP, $tmpfn{$month}) || die "$THIS_FILE: $!";
		flock (TEMP, LOCK_SH) || die "$THIS_FILE: $!";
		if ($COMPRESS) {
			# Write to a compressed file gYɤ
			$gz = gzopen($path, "wb9") || die "$THIS_FILE: " . $gz->gzerror();
			while (defined ($_ = <TEMP>)) {
				$gz->gzwrite($_) || die "$THIS_FILE: " . $gz->gzerror();
			}
			$gz->gzclose() && die "$THIS_FILE: " . $gz->gzerror();
		} else {
			# Write to an ordinary file g@ɤ
			open (RESULT, ">$path") || die "$THIS_FILE: $!";
			flock (RESULT, LOCK_EX) || die "$THIS_FILE: $!";
			print RESULT while <TEMP>;
			flock (RESULT, LOCK_UN) || die "$THIS_FILE: $!";
			close (RESULT) || die "$THIS_FILE: $!";
		}
		# Close the temporary working file Ȧs
		flock (TEMP, LOCK_UN) || die "$THIS_FILE: $!";
		close (TEMP) || die "$THIS_FILE: $!";
		
		# Delete the temporary working files RȦs
		unlink ($tmpfn{$month}) || die "$THIS_FILE: $!";
		print "done\n" if $VERBOSE >= 2;
		
		# Report the statistics ^έpƦr
		if ($COMPRESS) {
			$size_comp = -s $path;
			$ratio = sprintf "%4.2f", ($size_comp/$size_src)*100;
			$size_src = format_number($size_src);
			$size_comp = format_number($size_comp);
			print "$file compressed from $size_src bytes to $size_comp bytes, ratio $ratio%\n" if $VERBOSE >= 1;
		}
	}
	return;
}

# to_yyyymm: convert timestamp to yyyymm Nɶର yyyymm 榡
sub to_yyyymm {
	local $_;
	@_ = localtime $_[0];
	return sprintf "%04d%02d", $_[5] + 1900, $_[4] + 1;
}

# format_number: Format the number every 3 digit ƦrCTƥ[@J
sub format_number {
	local $_;
	$_ = $_[0];
	# Group every 3 digit CTƥ[@J
	$_ = $1 . "," . $2 . $3 while /^([^\.]*\d)(\d\d\d)(.*)$/;
	return $_;
}

# rel2abs: Convert a relative path to an absolute path ۹|ର|
sub rel2abs {
	local $_;
	my ($user, $path, $base);
	($path, $base) = @_;
	
	# Turn the base absolute Ҭ۹諸|ন|
	$base = cwd unless defined $base;
	$base = rel2abs ($base) if !file_name_is_absolute $base;
	
	# Deal the ~ home directories under UNIX b UNIX UBz ~ ϥΪ̪ڥؿ
	if (defined $Config{"d_getpwent"}) {
		@_ = splitdir ($path);
		# If start from user's home directory YOqϥΪ̮ڥؿ}l
		if ($_[0] =~ /^~(.*)$/) {
			$user = $1;
			# Get the current user if user not specified YϥΪ̨S]wAHثeϥΪ̬
			$user = getlogin if $user eq "";
			# Get the user home directory oϥΪ̮ڥؿ
			$_ = (getpwnam $user)[7];
			# Replace with the user home directory NϥΪ̮ڥؿ
			$_[0] = $_ if defined $_;
			# Compose the path զX|
			$path = catfile @_;
		}
	}
	
	# Append the current directory if relative ۹|Wثe|
	$path = catfile ($base, $path) unless file_name_is_absolute $path;
	
	@_ = splitdir ($path);			# Split into directory components Uhؿ
	# Add an empty filename level if last level is a directory ̫@hOؿɡA[WťɦWh
	push @_, "" if ($_[@_-1] eq curdir || $_[@_-1] eq updir);
	for ($_ = 1; $_ < @_; $_++) {		# Parse each level one by one @h@hR
		# If it is this directory oӥؿ
		if ($_[$_] eq curdir) {
			splice (@_, $_, 1);	# Remove this level directly ho@h
			$_--;			# The level number drop by 1 hƴ@
		# If it is the parent directory W@hؿ
		} elsif ($_ > 1 && $_[$_] eq updir && $_[$_-1] ne updir) {
			splice (@_, $_-1, 2);	# Remove this and the previous level ho@hMW@h
			$_ -= 2;		# The level number drop by 2 hƴG
		}
	}
	$path = catfile (@_);			# Compose the full path զX|
	return $path;
}

__END__

=head1 NAME

arclog.pl - Archive log files monthly

=head1 SYNOPSIS

 arclog.pl [options] logfile
 arclog.pl [-h|-v]

=head1 DESCRIPTION

arclog.pl archives the log files monthly. It strips off the log
entries that belongs to the previous months, and save them to the
archived files named F<logfile.yyyymm>. The archive files will be
compressed. The entries of the current month will be kept in the
source. It then saves disk spaces and prevents potentially attacks
on log files.

Current, only the F<apache> access log and L<syslog(2)|syslog/2>
formats are recognized.

Notice: Archiving takes time, especially on large log files. If
logging continues when you archive the file, it might be destroyed by
simultaneously writing. F<arclog.pl> uses L<flock(2)|flock/2> to
obtain an exclusive locking on the file to avoid such a racing
condition. But not all programs, especially the logging mechanisms
like L<httpd(8)|httpd/8> or L<syslogd(8)|syslogd/8>, use
L<flock(2)|flock/2>. (And, if they do, F<arclog.pl> would never have a
chance to work as long as they aren't turned off.) Make sure you are
not logging to that file when running F<arclog.pl>. You should always
turn off logging before running F<arclog.pl>, or run F<arclog.pl> on a
file that's not logging currently.

You could optionally sort the records in the archived files by time
(and then by record order), to solve some problems on merged log
files. But I<BE CAUTIONED>: C<Sorting> eats huge memory and CPU. If
you work on large log files, it might kill the whole system in one
minute. I had made some simple steps to avoid that, but I<I CAN'T
GUARANTEE THAT IT WORKS>. Whether it kills depends on which CPU you
have, how much memory you have and how large your archived file is.
Because of this, by default sorting is turned off.

Be careful on the L<syslog(2)|syslog/2> log files:
L<syslog(2)|syslog/2> does not record the year. F<arclog.pl> uses
L<Date::Parse(3)|Date::Parse/3> to parse the date, which will smartly
judge the year in the range between this month and last next month.
For ex., if today is 2001-06-08, it will judge the year between
2001-06-30 back to 2000-07-01 if the year is missing. I think this is
smart enough. However, if you do have a L<syslog(2)|syslog/2> log file
that has records older than that, don't use F<arclog.pl>. It will
destroy your log file.

=head1 OPTIONS

=over

=item logfile

The log file to be archived.

=item -p, --prefix pre

The prefix of the output files. The output files will be named as
F<pre.yyyymm>, ie: F<pre.200001>, F<pre.200002>. If not specified,
the default is the full pathname of the log file.

=item --compress

Compress the archived files. This is the default. Log files often have
simular lines all over. Compress them saves you lots of disk spaces.
(And this is why we want to I<archive> the log files.) Currently only
the L<gzip(1)|gzip/1> compressing method is supported.

=item --nocompress

Don't compress the archived files. (Are you sure? :p )

=item --sort

Sort the records by time (and then the record order). C<Sorting> eats
huge memory and CPU, so the default is disabled. See the description
above for a detailed illustration on sorting.

=item --nosort

Don't sort the records. This is the default.

=item --override[=mode]

Whether we should overwrite the existing archived files. Currently
the following modes are supported:

=over

=item overwrite

Overwrite any existing target file. If C<--override> was specified
without C<mode>, it assumes that you want to overwrite. You will lost
these existing log records. Use with care. This is only helpful if you
are sure the master log file has the most complete records.

=item append

Append the records to the existing target files. You might destroy the
log file completely by putting irrelevant entries altogether
accidently. Use with care. This is only helpful if you append want to
merge 2 log files, for ex., 2 log files in the same kind with
exclusive date ranges.

=item ignore

Ignore any existing target file, and discard all the records of those
months. You will lost these log records. Use with care. This is only
helpful if you are supplying log records for the missing months, or if
you are merging the log records in a complex manner.

=item fail

Stop processing whenever a target file exists, to prevent destroying
any existing files by accident. This is the default behavior, since
this is mostly wanted when run from some automatic mechanism like
crontab.

=item ask

Ask you what to do when a target file exists. This should be most
wanted if you are running this interactively. Don't set to ask if you
are running from non-interactively shells, like crontab. I don't know
what will happen then. Maybe it will wait indefinitely.

=back

=item -d, --debug

Show the detailed debugging messages.

=item -q, --quiet

Shihhhhhh. Only yell when errors.

=item -h, --help

Display the help message and exit.

=item -v, --version

Output version information and exit.

=back

=head1 VERSION

1.4.2dev

=head1 COPYRIGHT

Copyright (c) 2001 imacat. All rights reserved.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but I<WITHOUT ANY WARRANTY>; without even the implied warranty of
I<MERCHANTABILITY> or I<FITNESS FOR A PARTICULAR PURPOSE>.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

=head1 AUTHOR

imacat <imacat@mail.imacat.idv.tw>

=head1 BUGS

Please report if any. ^_*'

=head1 TODO

none

=head1 SEE ALSO

L<gzip(1)|gzip/1>, L<zlib(3)|zlib/3>, L<syslog(2)|syslog/2>

=cut
